import yaml
import cloud
import datetime

ResFile = "res/VMList_" + str(datetime.datetime.now()) + ".csv"  # Файл для записи информации о виртуальных машинах

# Загрузка конфигурации из файла config.yaml
for config in yaml.safe_load(open("config.yaml", "r")):
   # Создание объекта cloud с параметрами из конфигурации
   c = cloud.cloud(
       config['API_TOKEN'], 
       config['API_VERSION'], 
       config['SITE'], 
       config['TENANT'])
   
   # Получение списка виртуальных машин
   for vm in c.getVMList():
       sep = ";"
       # Вывод информации о виртуальных машинах в формате "name;OS;ipAddress;status"
       with open(ResFile, "a") as f:
        print(sep.join(vm.values()), file=f)
